#include <wchar.h>

size_t mbsrtowcs(wchar_t *dest, const char **src, size_t len, mbstate_t *ps)
{
	size_t i;
	const char *srcptr = *src;

	if(!dest)
		len = (size_t) -1;

	for(i = 0; i < len; ++i)
	{
		size_t n = mbrtowc(dest ? dest + i : 0, srcptr, len, ps);

		if(n == (size_t) -1)
		{
			i = (size_t) -1;
			break;
		}

		if(!n)
			break;

		srcptr += n;
	}

	if (dest)
	{
		if (i != (size_t) -1 && dest[i] == L'\0')
			*src = NULL; /* EOF */
		else
			*src = srcptr;
	}

	return i;
}
