#define _KERNEL
#include "ixemul.h"
#include <wchar.h>

size_t wcrtomb(char *s, wchar_t wc, mbstate_t *ps)
{
	char c;
	unsigned int bits,j,k;

	if(!s)
		return 1;

	if(!ps)
	{
		usetup;
		ps = &u_ptr->u_is;
	}

	if (wc>=0x04000000)
	{
		bits = 30;
		c = 0xFC;
		j = 6;
	}
	else if (wc>=0x00200000) 
	{
		bits = 24;
		c = 0xF8;
		j = 5;
	}
	else if (wc>=0x00010000)
	{
		bits = 18;
		c = 0xF0; 
		j = 4;
	}
	else if (wc>=0x00000800) 
	{
		bits = 12; 
		c = 0xE0; 
		j = 3;
	}
	else if (wc>=0x00000080) 
	{
		bits = 6; 
		c = 0xC0; 
		j = 2;
	}
	else
	{
		*s = wc;
		return 1;
	}

	c |= (unsigned char)(wc >> bits);

	if(s)
	{
		*s = c;
		for(k = 1; k < j; ++k)
		{
			bits -= 6;
			s[k] = 0x80 + ((wc >> bits) & 0x3f);
		}
	}

	return j;
}
