#define _KERNEL
#include "ixemul.h"
#include <stdlib.h>
#include <wchar.h>
#include <errno.h>

size_t wcsrtombs(char *dest, const wchar_t **src, size_t len, mbstate_t *ps)
{
	usetup;

	wchar_t c;
	char buf[MB_CUR_MAX];
	size_t cur;
	wchar_t *srcptr;

	if(!src || !*src)
	{
		errno = EINVAL;
		return -1;
	}

	srcptr = *src;
	for(cur = 0; (c = *srcptr); srcptr++)
	{
		size_t n;
		char* s = dest && len-cur >= MB_CUR_MAX ? dest+cur : buf;
		n = wcrtomb(s, c, ps);

		if(n == (size_t) -1)
			return -1;
		if(dest && s == buf)
		{
			/* check if we fit */
			if(len < n)
			{
				*src = srcptr;
				return cur;
			}

			memcpy(dest + cur, buf, n);
		}

		cur += n;
	}

	if(dest && len > cur)
		dest[cur] = '\0';

	if(dest)
		*src = srcptr;

	return cur;
}

